Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QPushButton

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.gui.QWidget
                          com.trolltech.qt.gui.QAbstractButton
                              com.trolltech.qt.gui.QPushButton

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

Direct Known Subclasses:
  QCommandLinkButton

    public class QPushButton

extends QAbstractButton

The `QPushButton` widget provides a command button. The push button, or command button, is perhaps the most commonly used widget in any graphical user interface. Push (click) a button to command the computer to perform some action, or to answer a question. Typical buttons are OK, Apply, Cancel, Close, Yes, No and Help.

A command button is rectangular and typically displays a text label describing its action. A shortcut key can be specified by preceding the preferred character with an ampersand in the text. For example:

            QPushButton button = new QPushButton("Download");

In this example the shortcut is Alt+D. See the `QShortcut` documentation for details (to display an actual ampersand, use '&&').

Push buttons display a textual label, and optionally a small icon. These can be set using the constructors and changed later using setText() and setIcon(). If the button is disabled the appearance of the text and icon will be manipulated with respect to the GUI style to make the button look "disabled".

A push button emits the signal `clicked()` when it is activated by the mouse, the Spacebar or by a keyboard shortcut. Connect to this signal to perform the button's action. Push buttons also provide less commonly used signals, for example, `pressed()` and `released()` .

Command buttons in dialogs are by default auto-default buttons, i.e. they become the default push button automatically when they receive the keyboard input focus. A default button is a push button that is activated when the user presses the Enter or Return key in a dialog. You can change this with `setAutoDefault()`. Note that auto-default buttons reserve a little extra space which is necessary to draw a default-button indicator. If you do not want this space around your buttons, call setAutoDefault(false).

Being so central, the button widget has grown to accommodate a great many variations in the past decade. The Microsoft style guide now shows about ten different states of Windows push buttons and the text implies that there are dozens more when all the combinations of features are taken into consideration.

The most important modes or states are:

- Available or not (grayed out, disabled).
- Standard push button, toggling push button or menu button.
- On or off (only for toggling push buttons).
- Default or normal. The default button in a dialog can generally be "clicked" using the Enter or Return key.
- Auto-repeat or not.
- Pressed down or not.

As a general rule, use a push button when the application or dialog window performs an action when the user clicks on it (such as Apply, Cancel, Close and Help) and when the widget is supposed to have a wide, rectangular shape with a text label. Small, typically square buttons that change the state of the window rather than performing an action (such as the buttons in the top-right corner of the `QFileDialog`) are not command buttons, but tool buttons. Qt provides a special class (`QToolButton`) for these buttons.

If you need toggle behavior (see setCheckable()) or a button that auto-repeats the activation signal when being pushed down like the arrows in a scroll bar (see setAutoRepeat()), a command button is probably not what you want. When in doubt, use a tool button.

A variation of a command button is a menu button. These provide not just one command, but several, since when they are clicked they pop up a menu of options. Use the method `setMenu()` to associate a popup menu with a push button.

Other classes of buttons are option buttons (see `QRadioButton`) and check boxes (see `QCheckBox`).

| A push button shown in the Macintosh widget style. Note that when a button's width becomes smaller than 50 or its height becomes smaller than 30, the button's corners are changed from round to square. Use the setMinimumSize() function to prevent this behavior.
| A push button shown in the Windows XP widget style.
| A push button shown in the Plastique widget style.

In Qt, the `QAbstractButton` base class provides most of the modes and other API, and `QPushButton` provides GUI logic. See `QAbstractButton` for more information about the API.

See also:
  `QToolButton`, `QRadioButton`, `QCheckBox`, and GUI Design Handbook: Push Button.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.gui.QAbstractButton
`clicked, pressed, released, toggled`

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QPushButton()` Constructs a push button with no text and a `parent`.
`QPushButton(QIcon icon, java.lang.String text)` Constructs a push button with an `icon` and a `text`, and a `parent`.
`QPushButton(QIcon icon, java.lang.String text, QWidget parent)` Constructs a push button with an `icon` and a `text`, and a `parent`.
`QPushButton(QWidget parent)` Constructs a push button with no text and a `parent`.
`QPushButton(java.lang.String text)` Constructs a push button with the parent `parent` and the text `text`.
`QPushButton(java.lang.String text, QWidget parent)` Constructs a push button with the parent `parent` and the text `text`.

Method Summary
`boolean` | `autoDefault()` This property holds whether the push button is an auto default button.
`protected void` | `initStyleOption(QStyleOptionButton option)` Initialize `option` with the values from this QPushButton.
`boolean` | `isDefault()` This property holds whether the push button is the default button.
`boolean` | `isFlat()` This property holds whether the button border is raised.
`QMenu` | `menu()` Returns the button's associated popup menu or 0 if no popup menu has been set.
`void` | `setAutoDefault(boolean arg__1)` This property holds whether the push button is an auto default button.
`void` | `setDefault(boolean arg__1)` This property holds whether the push button is the default button.
`void` | `setFlat(boolean arg__1)` This property holds whether the button border is raised.
`void` | `setMenu(QMenu menu)` Associates the popup menu `menu` with this push button.
`void` | `showMenu()` Shows (pops up) the associated popup menu.

Methods inherited from class com.trolltech.qt.gui.QAbstractButton
`animateClick, animateClick, autoExclusive, autoRepeat, autoRepeatDelay, autoRepeatInterval, checkStateSet, click, group, hitButton, icon, iconSize, isCheckable, isChecked, isDown, nextCheckState, setAutoExclusive, setAutoRepeat, setAutoRepeatDelay, setAutoRepeatInterval, setCheckable, setChecked, setDown, setIcon, setIconSize, setShortcut, setShortcut, setShortcut, setText, shortcut, text, toggle`

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, changeEvent, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, closeEvent, contentsRect, contextMenuEvent, contextMenuPolicy, cursor, depth, destroy, destroy, destroy, dragEnterEvent, dragLeaveEvent, dragMoveEvent, dropEvent, effectiveWinId, ensurePolished, enterEvent, focusInEvent, focusNextChild, focusNextPrevChild, focusOutEvent, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, hideEvent, inputContext, inputMethodEvent, inputMethodQuery, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isMaximized, isMinimized, isModal, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, keyPressEvent, keyReleaseEvent, languageChange, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumSizeHint, minimumWidth, mouseDoubleClickEvent, mouseGrabber, mouseMoveEvent, mousePressEvent, mouseReleaseEvent, move, move, moveEvent, nativeParentWidget, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, paintEngine, paintEvent, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, resizeEvent, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFilePath, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showEvent, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeHint, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, wheelEvent, width, widthMM, window, windowFilePath, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QPushButton

    public QPushButton()

  Constructs a push button with no text and a `parent`.

### QPushButton

    public QPushButton(QWidget parent)

  Constructs a push button with no text and a `parent`.

### QPushButton

    public QPushButton(QIcon icon,
                       java.lang.String text)

  Constructs a push button with an `icon` and a `text`, and a `parent`.

  Note that you can also pass a `QPixmap` object as an icon (thanks to the implicit type conversion provided by C++).

### QPushButton

    public QPushButton(QIcon icon,
                       java.lang.String text,
                       QWidget parent)

  Constructs a push button with an `icon` and a `text`, and a `parent`.

  Note that you can also pass a `QPixmap` object as an icon (thanks to the implicit type conversion provided by C++).

### QPushButton

    public QPushButton(java.lang.String text)

  Constructs a push button with the parent `parent` and the text `text`.

### QPushButton

    public QPushButton(java.lang.String text,
                       QWidget parent)

  Constructs a push button with the parent `parent` and the text `text`.

Method Detail

### autoDefault

    public final boolean autoDefault()

  This property holds whether the push button is an auto default button. If this property is set to true then the push button is an auto default button.

  In some GUI styles a default button is drawn with an extra frame around it, up to 3 pixels or more. Qt automatically keeps this space free around auto-default buttons, i.e. auto-default buttons may have a slightly larger size hint.

  This property's default is true for buttons that have a `QDialog` parent; otherwise it defaults to false.

  See the `default` property for details of how `default` and auto-default interact.

### isDefault

    public final boolean isDefault()

  This property holds whether the push button is the default button. Default and autodefault buttons decide what happens when the user presses enter in a dialog.

  A button with this property set to true (i.e., the dialog's default button,) will automatically be pressed when the user presses enter, with one exception: if an `autoDefault` button currently has focus, the `autoDefault` button is pressed. When the dialog has `autoDefault` buttons but no default button, pressing enter will press either the `autoDefault` button that currently has focus, or if no button has focus, the next `autoDefault` button in the focus chain.

  In a dialog, only one push button at a time can be the default button. This button is then displayed with an additional frame (depending on the GUI style).

  The default button behavior is provided only in dialogs. Buttons can always be clicked from the keyboard by pressing Spacebar when the button has focus.

  If the default property is set to false on the current default button while the dialog is visible, a new default will automatically be assigned the next time a pushbutton in the dialog receives focus.

  This property's default is false.

### isFlat

    public final boolean isFlat()

  This property holds whether the button border is raised. This property's default is false. If this property is set, most styles will not paint the button background unless the button is being pressed. setAutoFillBackground() can be used to ensure that the background is filled using the `QPalette::Button` brush.

### menu

    public final QMenu menu()

  Returns the button's associated popup menu or 0 if no popup menu has been set.

See also:
  `setMenu()`.

### setAutoDefault

    public final void setAutoDefault(boolean arg__1)

  This property holds whether the push button is an auto default button. If this property is set to true then the push button is an auto default button.

  In some GUI styles a default button is drawn with an extra frame around it, up to 3 pixels or more. Qt automatically keeps this space free around auto-default buttons, i.e. auto-default buttons may have a slightly larger size hint.

  This property's default is true for buttons that have a `QDialog` parent; otherwise it defaults to false.

  See the `default` property for details of how `default` and auto-default interact.

### setDefault

    public final void setDefault(boolean arg__1)

  This property holds whether the push button is the default button. Default and autodefault buttons decide what happens when the user presses enter in a dialog.

  A button with this property set to true (i.e., the dialog's default button,) will automatically be pressed when the user presses enter, with one exception: if an `autoDefault` button currently has focus, the `autoDefault` button is pressed. When the dialog has `autoDefault` buttons but no default button, pressing enter will press either the `autoDefault` button that currently has focus, or if no button has focus, the next `autoDefault` button in the focus chain.

  In a dialog, only one push button at a time can be the default button. This button is then displayed with an additional frame (depending on the GUI style).

  The default button behavior is provided only in dialogs. Buttons can always be clicked from the keyboard by pressing Spacebar when the button has focus.

  If the default property is set to false on the current default button while the dialog is visible, a new default will automatically be assigned the next time a pushbutton in the dialog receives focus.

  This property's default is false.

### setFlat

    public final void setFlat(boolean arg__1)

  This property holds whether the button border is raised. This property's default is false. If this property is set, most styles will not paint the button background unless the button is being pressed. setAutoFillBackground() can be used to ensure that the background is filled using the `QPalette::Button` brush.

### setMenu

    public final void setMenu(QMenu menu)

  Associates the popup menu `menu` with this push button. This turns the button into a menu button, which in some styles will produce a small triangle to the right of the button's text.

  Ownership of the menu is not transferred to the push button.

  |  | Push buttons with popup menus shown in the Plastique widget style (left) and Cleanlooks widget style (right).

See also:
  `menu()`.

### showMenu

    public final void showMenu()

  Shows (pops up) the associated popup menu. If there is no such menu, this function does nothing. This function does not return until the popup menu has been closed by the user.

### initStyleOption

    protected final void initStyleOption(QStyleOptionButton option)

  Initialize `option` with the values from this QPushButton. This method is useful for subclasses when they need a QStyleOptionButton, but don't want to fill in all the information themselves.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD